Psi4: Open-Source Quantum Chemistry
-----------------------------------

* **Users' Website**  www.psicode.org

* **Downloading and Installing Psi4** https://github.com/psi4/psi4/wiki

* **Manual**  [http://bit.ly/psi4manual](http://psicode.org/psi4manual/master/index.html) (built nightly from master branch)

* **Tutorial** http://psicode.org/psi4manual/master/tutorial.html

* **Forum** http://forum.psicode.org

* **Communication & Support** http://psicode.org/psi4manual/master/introduction.html#technical-support

* **Public Github**  https://github.com/psi4/psi4 (authoritative repository)

* **Private Github**  https://github.com/psi4/psi4private (scheduled to become read-only mirror of public GitHub master)

* **Travis CI build status** [![Build Status](https://travis-ci.org/psi4/psi4.svg?branch=master)](https://travis-ci.org/psi4/psi4)

* **Anaconda**  https://anaconda.org/psi4 (binary available for Linux [![Binstar Badge](https://anaconda.org/psi4/psi4/badges/downloads.svg)](https://anaconda.org/psi4/psi4) ) [instructions](http://psicode.org/psi4manual/master/conda.html#quick-installation)

* **Interested Developers**  http://psicode.org/developers.php (welcome to fork psi4/psi4 or store private branches at psi4/psi4private)

* **Sample Inputs**  http://www.psicode.org/psi4manual/master/testsuite.html (also in share/psi4/samples)

* **Download Tarball** https://github.com/psi4/psi4/releases 

* **Build Dashboard** https://testboard.org/cdash/index.php?project=Psi

* **YouTube Channel** https://www.youtube.com/psitutorials

Psi4 is an open-source suite of ab initio quantum chemistry programs
designed for efficient, high-accuracy simulations of a variety of
molecular properties. We can routinely perform computations with more
than 2500 basis functions running serially or on multi-core machines.

With computationally demanding portions written in C++, Boost exports
of many C++ classes into Python, and a flexible Python driver, Psi4
strives to be friendly to both users and developers.

